// Class Code 03A - Easing
// Easing is a motion that allows the moved object 
// to move to its final location in a mor natural way.
// This is adapted from John Gruen's work in previous 
// terms.

// golbal variables
float x, y, diam, easingCoefficient;

void setup( )
{
  size( 400, 400 );
  x = width/2;
  y = height/2;
  diam = width*.15;
  
  // alter this value to change the speed of the
  // circle's movement to the mouse location
  easingCoefficient = 0.1;
  
  smooth( );
  fill( 200, 0, 0 );
}

void draw( )
{
  background( 0 );
  
  // local variables
  // compute distance between current circle location and mouse location.
  float dx = mouseX - x;
  float dy = mouseY - y;
  
  // change x and y by an amount equal to the distance between 
  // the mouse and the circle multiplied by the easingCoefficient
  
  x = x + ( dx * easingCoefficient );
  y = y + ( dy * easingCoefficient );
  
  // draw the ellipse
  ellipse( x, y, diam, diam );
  
}
